"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DialogTitle = function DialogTitle(props) {
    var closeIcon;
    if (props.hasCloseIcon !== false) {
        closeIcon = _react2.default.createElement("i", { className: "icon icon-close", onClick: props.onClose });
    }

    var minimizeIcon;
    if (props.allowMinimize) {
        if (props.isMinimized) {
            minimizeIcon = _react2.default.createElement("i", { className: "icon icon-restore", onClick: props.onRestore });
        } else {
            minimizeIcon = _react2.default.createElement("i", { className: "icon icon-minimize", onClick: props.onMinimize });
        }
    }

    var maximizeIcon;
    if (props.allowMaximize) {
        if (props.isMaximized) {
            maximizeIcon = _react2.default.createElement("i", { className: "icon icon-restore", onClick: props.onRestore });
        } else {
            maximizeIcon = _react2.default.createElement("i", { className: "icon icon-maximize", onClick: props.onMaximize });
        }
    }

    return _react2.default.createElement(
        "header",
        { className: "ui-dialog-titlebar" },
        _react2.default.createElement(
            "div",
            { className: "title" },
            props.title
        ),
        _react2.default.createElement(
            "div",
            { className: "action-items" },
            minimizeIcon,
            maximizeIcon,
            closeIcon
        )
    );
};

DialogTitle.propTypes = {
    hasCloseIcon: _propTypes2.default.bool,
    allowMinimize: _propTypes2.default.bool,
    allowMaximize: _propTypes2.default.bool,
    isMinimized: _propTypes2.default.bool,
    isMaximized: _propTypes2.default.bool,
    title: _propTypes2.default.string,
    onClose: _propTypes2.default.func.isRequired,
    onMinimize: _propTypes2.default.func,
    onMaximize: _propTypes2.default.func,
    onRestore: _propTypes2.default.func
};

exports.default = DialogTitle;